﻿package classes {
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.events.Event;
	
	public class Main extends Sprite {
		
		private var _imagebmd:BitmapData = new Sample(0 , 0 );
		private var _imageContainer:Sprite;
		private var _imageContainerX:Number;
		private var _imageContainerY:Number;
		private var _canvas:BitmapData;
		private var _canvasContainer:Sprite;
		private var _rectWidth:Number = 100;
		private var _rectHeight:Number = 100;
		private var _images:Array;
		private var _click:Boolean = false;
		
		public function Main() {
			stage.scaleMode = "noScale";
			stage.align = "TL";
			
			init();
		}
		
		private function init() {
			_canvasContainer = new Sprite;
			addChild(_canvasContainer);
			addcanvas()
			
			_imageContainer = new Sprite();
			addChild(_imageContainer);
			addimage( stage.stageWidth/2 , stage.stageHeight/2);
			
			var fps:Fps = new Fps();
			addChild(fps);
			
			_images = [];
			stage.addEventListener(MouseEvent.CLICK , checkClick );
			stage.addEventListener(Event.RESIZE , onResizeFunc ) ;
			addEventListener( Event.ENTER_FRAME , update );
		}
		
		private function addcanvas() {
			if ( _canvasContainer.numChildren ) {
				_canvasContainer.removeChildAt(0);
			}
			_canvas = new BitmapData( stage.stageWidth , stage.stageHeight , false , 0x0  );
			_canvasContainer.addChildAt( new Bitmap( _canvas ,"auto" , true ) , 0 );
		}
		
		private function addimage(w:Number , h:Number):void {
			if ( _imageContainer.numChildren ) {
				_imageContainer.removeChildAt(0);
			}
			_imageContainer.addChildAt( new Bitmap( _imagebmd ) ,0 );
			_imageContainerX = w - _imagebmd.width/2;
			_imageContainerY = h - _imagebmd.height/2;
			_imageContainer.x = _imageContainerX;
			_imageContainer.y = _imageContainerY;
		}
		
		private function onResizeFunc(e:Event):void {
			addcanvas()
			addimage( stage.stageWidth/2 , stage.stageHeight/2);
		}

		private function checkClick(e:MouseEvent):void {
			
			if ( !_click ) {
				_imageContainer.removeChildAt(0);
				createRect();
			} else {
				addimage(this.mouseX , this.mouseY);
				//_images = [];
			}
			
			_click = !_click;
		}
		
		private function createRect():void {
			
			for (var ex:int = 0; ex < _imagebmd.width ; ex += _rectWidth ) {
				for (var ey:int = 0; ey < _imagebmd.height ; ey += _rectHeight) {
					var bmd:BitmapData = new BitmapData( _rectWidth , _rectHeight , false , 0x0 );
					bmd.draw( _imagebmd , new Matrix(1 , 0 , 0 , 1  , -ex , -ey ) ) ;
					setParticle( bmd , ex , ey , Math.random() * 1 -0.5 , Math.random() * -1   , Math.random() * 0.2 -0.1  , Math.random() * -0.1 , Math.random() * 0.1 -0.05 , Math.random() * -0.01 );
				}	
			}
			
		}
		
		private function setParticle($bmd:BitmapData , $x:Number , $y:Number , $vx:Number = 0 , $vy:Number = 0 , $ax:Number = 0 , $ay:Number = 0 , $vrot:Number = 0 , $vscale:Number = 0 ) {
			var p:BmdParticle = new BmdParticle();
			p.bmd = $bmd;
			p.x = $x + _imageContainerX;
			p.y = $y + _imageContainerY;
			p.vx = $vx;
			p.vy = $vy;
			p.vrot = $vrot;
			p.ax = $ax;
			p.ay = $ay;
			p.vscale = $vscale;
			_images.push(p);
		}

		
		private function update(e:Event):void {
			_canvas.lock();
			_canvas.fillRect(_canvas.rect , 0x0 );
			
			for (var i:int = _images.length - 1 ; i > 0 ; i--) {
				var p:BmdParticle = _images[i];
				p.vy +=  -0.1;
				p.vx *= 0.99;
				p.vy *= 0.99;
				p.vrot *= 0.99;
				p.vx += p.ax;
				p.vy += p.ay;
				p.vrot += p.arot;
				p.x += p.vx;
				p.y += p.vy;
				p.rot += p.vrot;
				p.scale += p.vscale;
				var matrix:Matrix = new Matrix();
				matrix.createBox( p.scale , p.scale , p.rot , p.x , p.y );
				_canvas.draw( p.bmd , matrix  ) ;

				if ( p.y < 0 ) {
					_images.splice( i , 1 );
				}
			}
			
			_canvas.unlock();
			
		}
		
	}
	
}

import flash.display.BitmapData;

class BmdParticle {
	public var x:Number;
	public var y:Number;
	public var bmd:BitmapData;
	public var vx:Number;
	public var vy:Number;
	public var ax:Number;
	public var ay:Number;
	public var arot:Number;
	public var vrot:Number;
	public var rot:Number;
	public var scale:Number;
	public var vscale:Number;
	
	public function BmdParticle() {
		this.x = 0;
		this.y = 0;
		this.rot = 0;
		this.vy = 0;
		this.vx = 0;
		this.vrot = 0;
		this.ay = 0;
		this.ax = 0;
		this.arot = 0;
		this.scale = 1;
		this.vscale = 0;
	}
}